﻿
CREATE TABLE characters (
    name text NOT NULL,
    class text NOT NULL,
    race text NOT NULL,
    level integer NOT NULL,
	user_name text NOT NULL,
	server text NOT NULL
);
CREATE TABLE servers (
    address text NOT NULL,
    name text NOT NULL,
    location text,
    max_users integer,
    connected_users integer
);

CREATE TABLE stores (
    address text NOT NULL,
    character_name text NOT NULL
);

CREATE TABLE users (
    user_name text NOT NULL,
    balance integer,
    first_name text,
    last_name text,
    iban text,
    character_slots integer,
    last_payment timestamp without time zone,
    months_payed integer,
    password text NOT NULL,
    banned boolean
);
ALTER TABLE ONLY servers
    ADD CONSTRAINT servers_pkey PRIMARY KEY (address);
	
ALTER TABLE ONLY users
    ADD CONSTRAINT users_pkey PRIMARY KEY (user_name);
	
ALTER TABLE ONLY stores
    ADD CONSTRAINT stores_pkey PRIMARY KEY (address, character_name);
	
ALTER TABLE ONLY characters
    ADD CONSTRAINT characters_pkey PRIMARY KEY (name,server);
	
ALTER TABLE ONLY characters
    ADD CONSTRAINT characters_user_name_fkey FOREIGN KEY (user_name) REFERENCES users(user_name);
	
ALTER TABLE ONLY characters
	ADD CONSTRAINT characters_server_fkey FOREIGN KEY (server) REFERENCES servers(address);
	
INSERT INTO servers VALUES ('192.168.0.1','Nederland','Rotterdam',1,0);
INSERT INTO servers VALUES ('192.168.0.2','Turkije','Turkije',1,0);

INSERT INTO users VALUES ('wouter',0,'Wouter','Naloop','rekeningenzo',3,null,null,'wouter',false);
INSERT INTO users VALUES ('jorik',0,'Jorik','Schouten','rekeningenzo',3,null,null,'jorik',false);

INSERT INTO characters VALUES('xXGay_Weed_Dad_69Xx','DIKKEBMW','BRANDWEERAUTO',10,'jorik','192.168.0.1');
INSERT INTO characters VALUES('JeBoyWouter42','DERPSLET','FRUITVLIEG',15,'wouter','192.168.0.2');
