package gui;

import app.Main;
import jpa.UsersEntity;
import org.hibernate.Session;
import org.hibernate.Transaction;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Created by Wouter on 10/24/2015.
 */
public class LoginFrame extends JFrame{
    private Main main;
    public LoginFrame(Main main) throws HeadlessException {
        this.main = main;
        initComponents();
    }

    private void initComponents() {

        loginPane = new javax.swing.JPanel();
        usernameField = new javax.swing.JTextField();
        passwordField = new javax.swing.JPasswordField();
        pageTitle = new javax.swing.JLabel();
        loginButton = new javax.swing.JButton();
        registerLoginButton = new javax.swing.JButton();
        errorLabel = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        loginPane.setEnabled(false);
        usernameField.setText("Username");

        passwordField.setText("");
        passwordField.setCursor(new java.awt.Cursor(java.awt.Cursor.TEXT_CURSOR));

        pageTitle.setFont(new java.awt.Font("Tekton Pro Ext", 0, 48)); // NOI18N
        pageTitle.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);


        loginButton.setText("Login");
        loginButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loginButtonActionPerformed(evt);
            }
        });

        registerLoginButton.setText("Register");
        registerLoginButton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                registerLoginButtonClicked();
            }
        });
        javax.swing.GroupLayout loginPaneLayout = new javax.swing.GroupLayout(loginPane);
        loginPane.setLayout(loginPaneLayout);
        loginPaneLayout.setHorizontalGroup(
                loginPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(loginPaneLayout.createSequentialGroup()
                                .addGap(87, 87, 87)
                                .addGroup(loginPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                        .addComponent(pageTitle, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(passwordField)
                                        .addComponent(usernameField)
                                        .addGroup(loginPaneLayout.createSequentialGroup()
                                                .addComponent(registerLoginButton)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(loginButton, javax.swing.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE))
                                        .addComponent(errorLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addContainerGap(85, Short.MAX_VALUE))
        );
        loginPaneLayout.setVerticalGroup(
                loginPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, loginPaneLayout.createSequentialGroup()
                                .addGap(33, 33, 33)
                                .addComponent(pageTitle, javax.swing.GroupLayout.PREFERRED_SIZE, 79, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 14, Short.MAX_VALUE)
                                .addComponent(errorLabel)
                                .addGap(18, 18, 18)
                                .addComponent(usernameField, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(passwordField, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addGroup(loginPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                        .addComponent(loginButton, javax.swing.GroupLayout.DEFAULT_SIZE, 33, Short.MAX_VALUE)
                                        .addComponent(registerLoginButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGap(0, 400, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addGroup(layout.createSequentialGroup()
                                        .addContainerGap()
                                        .addComponent(loginPane, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addContainerGap()))
        );
        layout.setVerticalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGap(0, 300, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addGroup(layout.createSequentialGroup()
                                        .addContainerGap()
                                        .addComponent(loginPane, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addContainerGap()))
        );
        this.setResizable(false);
        setPageLogo();
        pack();
    }
    private void setPageLogo(){
        ImageIcon imgThisImg = new ImageIcon("logo.jpg");
        Image image = imgThisImg.getImage(); // transform it
        Image newimg = image.getScaledInstance(100, 80,  java.awt.Image.SCALE_SMOOTH); // scale it the smooth way
        imgThisImg = new ImageIcon(newimg);  // transform it back
        pageTitle.setIcon(imgThisImg);
        pageTitle.setSize(400,400);
    }
    private void registerLoginButtonClicked() {
        final Session session = main.getSession();
        try {
            UsersEntity user = main.getUser(session, usernameField.getText());
            if(user == null){
                main.switchFrame(main.REGISTERFRAME);
            }
            else{
                errorLabel.setText("Username already exists!");
                throw new Exception("Username already exists!");
            }
        }catch (Exception e){
            e.printStackTrace();
            errorLabel.setText(e.getMessage());
        }
        finally
        {
            session.close();
        }

    }

    private void loginButtonActionPerformed(java.awt.event.ActionEvent evt) {
        final Session session = main.getSession();

        boolean loggedIn = false;
        try {
            UsersEntity user = main.getUser(session, usernameField.getText());
            if(user == null){
                throw new Exception("Username does not exist");
            }
            if(user.getPassword().equals(new String(passwordField.getPassword()))){
                main.setUserLoggedIn(user);
                loggedIn = true;
                main.switchFrame(main.CHARACTERFRAME);
            }else{
                throw new Exception("Wrong Password");
            }
        }catch (Exception e){
            e.printStackTrace();
            errorLabel.setText(e.getMessage());
        }
        finally
        {
            session.close();
        }

    }

    // Variables declaration - do not modify
    private javax.swing.JLabel errorLabel;
    private javax.swing.JButton loginButton;
    private javax.swing.JPanel loginPane;
    private javax.swing.JLabel pageTitle;
    private javax.swing.JPasswordField passwordField;
    private javax.swing.JButton registerLoginButton;
    private javax.swing.JTextField usernameField;
    // End of variables declaration

}
