package gui;

import app.Main;
import jpa.UsersEntity;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.exception.ConstraintViolationException;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;

/**
 * Created by Wouter on 10/24/2015.
 */
public class RegisterFrame extends JFrame{
    private Main main;
    public RegisterFrame(Main main) throws HeadlessException {
        this.main = main;
        initComponents();
    }
    private void initComponents() {

        RegisterPane = new javax.swing.JPanel();
        usernameLabel = new javax.swing.JLabel();
        passwordLabel = new javax.swing.JLabel();
        firstnameLabel = new javax.swing.JLabel();
        lastnameLabel = new javax.swing.JLabel();
        usernameRegisterField = new javax.swing.JTextField();
        passwordRegisterField = new javax.swing.JPasswordField();
        firstnameRegisterField = new javax.swing.JTextField();
        lastnameRegisterField = new javax.swing.JTextField();
        registerButton = new javax.swing.JButton();
        backButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        usernameLabel.setText("Username");

        passwordLabel.setText("Password");

        firstnameLabel.setText("first name");

        lastnameLabel.setText("last name");

        passwordRegisterField.setText("");

        registerButton.setText("Register");
        registerButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                registerButtonActionPerformed(evt);
            }
        });

        backButton.setText("Back");
        backButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                backButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout RegisterPaneLayout = new javax.swing.GroupLayout(RegisterPane);
        RegisterPane.setLayout(RegisterPaneLayout);
        RegisterPaneLayout.setHorizontalGroup(
                RegisterPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(RegisterPaneLayout.createSequentialGroup()
                                .addGroup(RegisterPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(usernameLabel)
                                        .addComponent(passwordLabel)
                                        .addComponent(firstnameLabel)
                                        .addComponent(lastnameLabel))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addGroup(RegisterPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                        .addComponent(usernameRegisterField)
                                        .addComponent(passwordRegisterField, javax.swing.GroupLayout.DEFAULT_SIZE, 235, Short.MAX_VALUE)
                                        .addComponent(firstnameRegisterField)
                                        .addComponent(lastnameRegisterField, javax.swing.GroupLayout.Alignment.TRAILING))
                                .addGap(47, 47, 47))
                        .addGroup(RegisterPaneLayout.createSequentialGroup()
                                .addComponent(backButton, javax.swing.GroupLayout.PREFERRED_SIZE, 136, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 49, Short.MAX_VALUE)
                                .addComponent(registerButton, javax.swing.GroupLayout.PREFERRED_SIZE, 185, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addContainerGap())
        );
        RegisterPaneLayout.setVerticalGroup(
                RegisterPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(RegisterPaneLayout.createSequentialGroup()
                                .addGap(39, 39, 39)
                                .addGroup(RegisterPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                        .addComponent(usernameRegisterField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(usernameLabel))
                                .addGap(23, 23, 23)
                                .addGroup(RegisterPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                        .addComponent(passwordLabel)
                                        .addComponent(passwordRegisterField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(30, 30, 30)
                                .addGroup(RegisterPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(firstnameLabel)
                                        .addComponent(firstnameRegisterField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(24, 24, 24)
                                .addGroup(RegisterPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                        .addComponent(lastnameLabel)
                                        .addComponent(lastnameRegisterField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 33, Short.MAX_VALUE)
                                .addGroup(RegisterPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                        .addComponent(registerButton)
                                        .addComponent(backButton))
                                .addGap(27, 27, 27))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(RegisterPane, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addContainerGap())
        );
        layout.setVerticalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addComponent(RegisterPane, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addContainerGap())
        );
        this.setResizable(false);
        pack();
    }

    private void registerButtonActionPerformed(ActionEvent evt) {
        final Session session = main.getSession();
        try {
            UsersEntity user = main.getUser(session, usernameRegisterField.getText());
            if(user == null){
                try {
                    Transaction tx = session.beginTransaction();
                    String username = usernameRegisterField.getText();
                    String password = new String(passwordRegisterField.getPassword());
                    String first_name = firstnameRegisterField.getText();
                    String last_name = lastnameRegisterField.getText();
                    user = new UsersEntity(username,0,first_name,last_name,"",3,null,0,password,false,null);
                    session.save(user);
                    tx.commit();
                    main.switchFrame(main.LOGINFRAME);
                }catch(ConstraintViolationException constrainViolation) {
                    String error = constrainViolation.getCause().getMessage();
                }catch (Exception normalException){

                }
                finally
                {
                    session.close();
                }
            }
            else{
                usernameRegisterField.setText("Username already exists!");
            }
        }catch (Exception e){
            e.printStackTrace();
            usernameRegisterField.setText(e.getMessage());
        }
        finally
        {
            session.close();
        }


    }

    private void backButtonActionPerformed(java.awt.event.ActionEvent evt) {
        main.switchFrame(main.LOGINFRAME);
    }

    // Variables declaration - do not modify
    private javax.swing.JPanel RegisterPane;
    private javax.swing.JButton backButton;
    private javax.swing.JLabel firstnameLabel;
    private javax.swing.JTextField firstnameRegisterField;
    private javax.swing.JLabel lastnameLabel;
    private javax.swing.JTextField lastnameRegisterField;
    private javax.swing.JLabel passwordLabel;
    private javax.swing.JPasswordField passwordRegisterField;
    private javax.swing.JButton registerButton;
    private javax.swing.JLabel usernameLabel;
    private javax.swing.JTextField usernameRegisterField;
    // End of variables declaration
}
