package jpa;

import javax.persistence.*;

/**
 * Created by Wouter on 10/28/2015.
 */
@Entity
@Table(name = "characters", schema = "public", catalog = "HansOnline")
@IdClass(CharactersEntityPK.class)
public class CharactersEntity {
    private String name;
    private String clazz;
    private String race;
    private int level;
    private String server;
    private ServersEntity serversByServer;
    private UsersEntity usersByUserName;

    @Id
    @Column(name = "name")
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "class")
    public String getClazz() {
        return clazz;
    }

    public void setClazz(String clazz) {
        this.clazz = clazz;
    }

    @Basic
    @Column(name = "race")
    public String getRace() {
        return race;
    }

    public void setRace(String race) {
        this.race = race;
    }

    @Basic
    @Column(name = "level")
    public int getLevel() {
        return level;
    }

    public void setLevel(int level) {
        this.level = level;
    }

    @Id
    @Column(name = "server")
    public String getServer() {
        return server;
    }

    public void setServer(String server) {
        this.server = server;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        CharactersEntity that = (CharactersEntity) o;

        if (level != that.level) return false;
        if (clazz != null ? !clazz.equals(that.clazz) : that.clazz != null) return false;
        if (name != null ? !name.equals(that.name) : that.name != null) return false;
        if (race != null ? !race.equals(that.race) : that.race != null) return false;
        if (server != null ? !server.equals(that.server) : that.server != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = name != null ? name.hashCode() : 0;
        result = 31 * result + (clazz != null ? clazz.hashCode() : 0);
        result = 31 * result + (race != null ? race.hashCode() : 0);
        result = 31 * result + level;
        result = 31 * result + (server != null ? server.hashCode() : 0);
        return result;
    }

    @Override
    public String toString() {
        return name;
    }

    @ManyToOne
    @JoinColumn(name = "server", referencedColumnName = "address", nullable = false , insertable = false,updatable = false)
    public ServersEntity getServersByServer() {
        return serversByServer;
    }

    public void setServersByServer(ServersEntity serversByServer) {
        this.serversByServer = serversByServer;
    }

    @ManyToOne
    @JoinColumns(@JoinColumn(name = "user_name", referencedColumnName = "user_name", nullable = false))
    public UsersEntity getUsersByUserName() {
        return usersByUserName;
    }

    public void setUsersByUserName(UsersEntity usersByUserName) {
        this.usersByUserName = usersByUserName;
    }
}
