package jpa;

import org.hibernate.Session;
import org.hibernate.Transaction;

import javax.persistence.*;
import java.util.Collection;

/**
 * Created by Wouter on 10/28/2015.
 */
@Entity
@Table(name = "servers", schema = "public", catalog = "HansOnline")
public class ServersEntity {
    private String address;
    private String name;
    private String location;
    private Integer maxUsers;
    private Integer connectedUsers;
    private Collection<CharactersEntity> charactersesByAddress;

    @Id
    @Column(name = "address")
    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    @Basic
    @Column(name = "name")
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Basic
    @Column(name = "location")
    public String getLocation() {
        return location;
    }

    public void setLocation(String location) {
        this.location = location;
    }

    @Basic
    @Column(name = "max_users")
    public Integer getMaxUsers() {
        return maxUsers;
    }

    public void setMaxUsers(Integer maxUsers) {
        this.maxUsers = maxUsers;
    }

    @Basic
    @Column(name = "connected_users")
    public Integer getConnectedUsers() {
        return connectedUsers;
    }

    public void setConnectedUsers(Integer connectedUsers) {
        this.connectedUsers = connectedUsers;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        ServersEntity that = (ServersEntity) o;

        if (address != null ? !address.equals(that.address) : that.address != null) return false;
        if (connectedUsers != null ? !connectedUsers.equals(that.connectedUsers) : that.connectedUsers != null)
            return false;
        if (location != null ? !location.equals(that.location) : that.location != null) return false;
        if (maxUsers != null ? !maxUsers.equals(that.maxUsers) : that.maxUsers != null) return false;
        if (name != null ? !name.equals(that.name) : that.name != null) return false;

        return true;
    }

    @Override
    public String toString() {
        return name;
    }

    @Override
    public int hashCode() {
        int result = address != null ? address.hashCode() : 0;
        result = 31 * result + (name != null ? name.hashCode() : 0);
        result = 31 * result + (location != null ? location.hashCode() : 0);
        result = 31 * result + (maxUsers != null ? maxUsers.hashCode() : 0);
        result = 31 * result + (connectedUsers != null ? connectedUsers.hashCode() : 0);
        return result;
    }

    @OneToMany(mappedBy = "serversByServer")
    public Collection<CharactersEntity> getCharactersesByAddress() {
        return charactersesByAddress;
    }

    public void setCharactersesByAddress(Collection<CharactersEntity> charactersesByAddress) {
        this.charactersesByAddress = charactersesByAddress;
    }
}
