package jpa;

import app.Main;
import org.hibernate.*;
import org.hibernate.Query;

import javax.persistence.*;
import java.sql.Timestamp;
import java.util.Collection;

/**
 * Created by Wouter on 10/28/2015.
 */
@Entity
@Table(name = "users", schema = "public", catalog = "HansOnline")
public class UsersEntity {
    private String userName;
    private Integer balance;
    private String firstName;
    private String lastName;
    private String iban;
    private Integer characterSlots;
    private Timestamp lastPayment;
    private Integer monthsPayed;
    private String password;
    private Boolean banned;
    private Collection<CharactersEntity> charactersesByUserName;

    public UsersEntity() {
    }

    public UsersEntity(String userName, Integer balance, String firstName, String lastName, String iban, Integer characterSlots, Timestamp lastPayment, Integer monthsPayed, String password, Boolean banned, Collection<CharactersEntity> charactersesByUserName) {
        this.userName = userName;
        this.balance = balance;
        this.firstName = firstName;
        this.lastName = lastName;
        this.iban = iban;
        this.characterSlots = characterSlots;
        this.lastPayment = lastPayment;
        this.monthsPayed = monthsPayed;
        this.password = password;
        this.banned = banned;
        this.charactersesByUserName = charactersesByUserName;
    }

    @Id
    @Column(name = "user_name")
    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    @Basic
    @Column(name = "balance")
    public Integer getBalance() {
        return balance;
    }

    public void setBalance(Integer balance) {
        this.balance = balance;
    }

    @Basic
    @Column(name = "first_name")
    public String getFirstName() {
        return firstName;
    }

    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    @Basic
    @Column(name = "last_name")
    public String getLastName() {
        return lastName;
    }

    public void setLastName(String lastName) {
        this.lastName = lastName;
    }

    @Basic
    @Column(name = "iban")
    public String getIban() {
        return iban;
    }

    public void setIban(String iban) {
        this.iban = iban;
    }

    @Basic
    @Column(name = "character_slots")
    public Integer getCharacterSlots() {
        return characterSlots;
    }

    public void setCharacterSlots(Integer characterSlots) {
        this.characterSlots = characterSlots;
    }

    @Basic
    @Column(name = "last_payment")
    public Timestamp getLastPayment() {
        return lastPayment;
    }

    public void setLastPayment(Timestamp lastPayment) {
        this.lastPayment = lastPayment;
    }

    @Basic
    @Column(name = "months_payed")
    public Integer getMonthsPayed() {
        return monthsPayed;
    }

    public void setMonthsPayed(Integer monthsPayed) {
        this.monthsPayed = monthsPayed;
    }

    @Basic
    @Column(name = "password")
    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    @Basic
    @Column(name = "banned")
    public Boolean getBanned() {
        return banned;
    }

    public void setBanned(Boolean banned) {
        this.banned = banned;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        UsersEntity that = (UsersEntity) o;

        if (balance != null ? !balance.equals(that.balance) : that.balance != null) return false;
        if (banned != null ? !banned.equals(that.banned) : that.banned != null) return false;
        if (characterSlots != null ? !characterSlots.equals(that.characterSlots) : that.characterSlots != null)
            return false;
        if (firstName != null ? !firstName.equals(that.firstName) : that.firstName != null) return false;
        if (iban != null ? !iban.equals(that.iban) : that.iban != null) return false;
        if (lastName != null ? !lastName.equals(that.lastName) : that.lastName != null) return false;
        if (lastPayment != null ? !lastPayment.equals(that.lastPayment) : that.lastPayment != null) return false;
        if (monthsPayed != null ? !monthsPayed.equals(that.monthsPayed) : that.monthsPayed != null) return false;
        if (password != null ? !password.equals(that.password) : that.password != null) return false;
        if (userName != null ? !userName.equals(that.userName) : that.userName != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = userName != null ? userName.hashCode() : 0;
        result = 31 * result + (balance != null ? balance.hashCode() : 0);
        result = 31 * result + (firstName != null ? firstName.hashCode() : 0);
        result = 31 * result + (lastName != null ? lastName.hashCode() : 0);
        result = 31 * result + (iban != null ? iban.hashCode() : 0);
        result = 31 * result + (characterSlots != null ? characterSlots.hashCode() : 0);
        result = 31 * result + (lastPayment != null ? lastPayment.hashCode() : 0);
        result = 31 * result + (monthsPayed != null ? monthsPayed.hashCode() : 0);
        result = 31 * result + (password != null ? password.hashCode() : 0);
        result = 31 * result + (banned != null ? banned.hashCode() : 0);
        return result;
    }

    @OneToMany(mappedBy = "usersByUserName")
    public Collection<CharactersEntity> getCharactersesByUserName() {
        return charactersesByUserName;
    }

    public void setCharactersesByUserName(Collection<CharactersEntity> charactersesByUserName) {
        this.charactersesByUserName = charactersesByUserName;
    }

}
